Attribute VB_Name = "Module02_SearchTPI_at_TPI_Col"
    Sub SearchTPI_At_TPI_Col()
Attribute SearchTPI_At_TPI_Col.VB_Description = "Ctrl+Shift+S causes a search of the TPI column C for a user defined TPI value"
Attribute SearchTPI_At_TPI_Col.VB_ProcData.VB_Invoke_Func = "S\n14"
    
'KEY= Ctrl+Shift+S
' causes a search of column C, TPI, of sheet AllTPI for a user defined TPI value
' The search supports wild cards or an exact x.xxxxx style number
' Then highlites what is found and
'  places a copy of that row at the top of the "AllITP" sheet.

    Dim Xf As Long ' to be the found column number
    Dim Yf As Long  ' to be the found row number
    Dim Valf As Double ' what is the value found in the cell found
    Dim ValfStr As String ' cell value to display
    Dim ShSearch As String  ' User Input: The sheet to be searched
    Dim lRow As Long ' last row number of the data
    Dim lCol As Long ' last column number of the data
    Dim lColi As Long 'the number of columns in the virgin AllTPI
    Dim TPIRangeCol3 As Range  ' range of actual data in column 3
    Dim AllDataRange As Range  ' range of actual data in sheet
    Dim TPIsrch As String  ' the TIP to be searched for, input from the user msgbox
    Dim MsgStr As String  ' long message box string to the user
    Dim Totaln As Long  ' A counter of the search results
    Dim rFirst As Range
    Dim r As Range
    Dim A As Range
    Dim MyString As String
    Dim Copyn As Long
    Dim CopyRow As Long
    Dim DeleteFlagCnt As Long
    Dim DeleteFlagNum As Long
    Dim TotalDeleteRowCnt As Long
    Dim YesNoAnswer As Integer
    Dim TotalDELETEFLAGRows As Long

    

    ShSearch = "AllTPI"
' Checking to see if the sheet name exists. If not then exits with a message
    For Each Sheet In ActiveWorkbook.Worksheets
        If Sheet.Name = ShSearch Then
            Exit For
        Else
            MsgStr = "There is no " + ShSearch + " sheet to Search, Please run: GenAllTPI"
            MsgBox MsgStr, vbOKOnly, "Missing Sheet"
        Exit Sub
        End If
    Next

    Sheets(ShSearch).Select
    
    lRow = Cells(Rows.Count, "C").End(xlUp).Row
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
    lColi = lCol   'The initial Column Count
'count the number of DELETE FLAG s found. If any keep The previous searches???
    DeleteFlagCnt = Application.WorksheetFunction.CountIf(Range(Cells(1, 2), Cells(lRow, 2)), "DELETE FLAG")
    TotalDeleteRowCnt = 0
    If DeleteFlagCnt > 0 Then
        MsgStr = "There has been " + CStr(DeleteFlagCnt) + " previous search(s).  Do you wish to keep them?"
        YesNoAnswer = MsgBox(MsgStr, vbQuestion + vbYesNo + vbDefaultButton2, "Keep Previous Searches")
        
        If YesNoAnswer = vbNo Then
            '********* Clean up previous TPI search via deletions
            Call DeleteSrchResultTopRows ' makes this Subroutine call to removed ONE previous search.
        Else
        End If
        
    End If
      
'*************************
    If YesNoAnswer = vbYes Then
'Count the number of rows from 1 to the last "DELETE FLAG" if anser is yes
        DeleteFlagNum = 0
        Yf = 1
        lRow = Cells(Rows.Count, 3).End(xlUp).Row   ' this is all row including search rows
'        lRow = Cells(Rows.Count, "C").End(xlUp).Row
        Do While DeleteFlagNum < DeleteFlagCnt  ' find number of rows holding previous searches
            Stopn = False
            Do While Yf < lRow
                If Cells(Yf, 2) = "DELETE FLAG" Then
                    Stopn = True
                    Yf = Yf + 1
                End If
            Yf = Yf + 1
                If Stopn Then Exit Do
                Stopn = False
            Loop
            DeleteFlagNum = DeleteFlagNum + 1
        Loop
       
       
'        Cells(Yf - 2, 23) = Yf - 2 ' this is the number of rows TO The last DELETE FLAG.
        Cells(Yf - 2, 27) = Yf - 2 ' this is the number of rows TO The last DELETE FLAG.
        Cells(Yf - 2, lColi + 5) = Yf - 2 ' this is the number of rows TO The last DELETE FLAG.
        
        
        TotalDeleteRowCnt = Yf - 2 ' new name
    Else
        TotalDeleteRowCnt = 0  ' however it is zero anyway since the delete top rows was run.
        Yf = 0
        lRow = Cells(Rows.Count, 3).End(xlUp).Row
    End If

    
    
    
'*************************
    
  
'******************* Clean up previous TPI search via deletions
 '   Call DeleteSrchResultTopRows ' makes this Subroutine call to removed ONE previous search.
'*************

'Start search for TPI
    Range("A1").Select
'Find the last non-blank cell in column 3
    lRow = Cells(Rows.Count, 3).End(xlUp).Row
    
'Find the last non-blank cell in row lRow.  If the cell has been used before it will not be blank as it
' will have hidden control characters.  To remove control characters used c.Clear or just rebuilt the sheet
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
           
' Clear all available cells after the titles to the historic colors and fonts
  '  Range(Cells(1, TotalDeleteRowCnt + 3), Cells(lRow, lCol)).Interior.Color = RGB(255, 255, 255) ' 255, 255, 255 => clear!
  '  Range(Cells(1, TotalDeleteRowCnt + 3), Cells(lRow, lCol)).Font.Color = RGB(0, 0, 0)  ' 0, 0, 0 => black!
  '  Range(Cells(1, TotalDeleteRowCnt + 3), Cells(lRow, lCol)).Font.FontStyle = "Normal" 'Clears font stytle from "Bold Italic"
    
'    Set AllDataRange = Application.Range(Cell1:="A3", Cell2:=Cells(lRow, lCol))
' Clear font color, font style, cell color of previous searches for the range after the last DELETE FLAG and table titles
If YesNoAnswer = vbYes Then
    Set TPIRangeCol3 = Application.Range(Cell1:=Cells(TotalDeleteRowCnt + 3, 3), Cell2:=Cells(lRow, 3))
    TPIRangeCol3.Font.Color = RGB(0, 0, 0) ' make colum 3 font data black, removes previous search color
    TPIRangeCol3.Interior.Color = RGB(255, 255, 255) ' make colum 3 clear fill, removes previous search color
    TPIRangeCol3.Font.FontStyle = "Normal" 'Clears font stytle from "Bold Italic"
Else
    Set TPIRangeCol3 = Application.Range(Cell1:=Cells(3, 3), Cell2:=Cells(lRow, 3))
    TPIRangeCol3.Font.Color = RGB(0, 0, 0) ' make colum 3 font data black, removes previous search color
    TPIRangeCol3.Interior.Color = RGB(255, 255, 255) ' make colum 3 clear fill, removes previous search color
    TPIRangeCol3.Font.FontStyle = "Normal" 'Clears font stytle from "Bold Italic"
End If



'Message providing the search criterial
    MsgStr = "Please Replace w/ the desired value. It must have a decimal point and be 5 decimal number! For an EXACT " + _
        "Search: Type Exact number: Examples: 48.00000 or 0.00506, but NOT 04.00000 nor .056. However wild cards " + _
        " are allowed: ? any single character, *=any number of following characters may be use instead.   Note: " + _
        "Table numbers are treated as TEXT in the format of *?.?????  So a good search might be 13.0????" + _
        " or 13.0* to yield both 13.00000 and 13.02345" + "  Or, *.00000 to yield all the integers! " + _
        " If you want them ordered differently run the sorting macro first."
        
        TPIsrch = InputBox(MsgStr, _
            "Search For YOUR Desired TPI Value", "Your Number Goes Here")
        
'    Range("Y1") = TPIsrch       ' debug
'    Range("Y2") = Len(TPIsrch)  ' debug
    
    nFail = False
'   'If Len(TextBox1) = 0 Then
    If Len(TPIsrch) = Len("Your Number Goes Here") Then
        MsgBox "Search Variable has not been Provided Properly."
        nFail = True
        'Range("Y1") = "nStop = True"
    ElseIf Len(TPIsrch) = Len("") Then
        MsgBox "Search Variable has not been Provided Properly."
        nFail = True
        'Range("Y1") = "nStop = True"
    ElseIf Len(TPIsrch) = Len(" ") Then
        MsgBox "Search Variable has not been Provided Properly."
        nFail = True
        'Range("Y1") = "nStop = True"
    Else
    End If
        
'   'Set A = Range("C:C")
'    Set A = Range(Cells(3, 3), Cells(lRow, 3))
'    Set A = Application.Range(Cell1:="C3", Cell2:=Cells(lRow, 3))
    Set A = Range(Cells(TotalDeleteRowCnt + 3, 3), Cells(lRow, 3)) 'only search from below the last DELETE FLAG row
    MyString = "  "
    Totaln = 0
    Do
        If nFail Then Exit Do
   
        If rFirst Is Nothing Then
         'Set rFirst = A.Find(What:=TPIsrch, After:=A(1))
            Set rFirst = A.Find(What:=TPIsrch, After:=A(1), lookat:=xlWhole)
            If rFirst Is Nothing Then Exit Do  'Finally this works when the data does not match anything
                Set r = rFirst
            Else
'               'Set r = A.Find(What:=TPIsrch, After:=r)
                Set r = A.Find(What:=TPIsrch, After:=r, lookat:=xlWhole)
                If r.Address = rFirst.Address Then Exit Do
            End If
        Totaln = Totaln + 1
        MyString = MyString & "  " & r.Offset(0, -2)
             
'***********************
        Xf = r.Column  'r is a range, this command finds the first Row of that range, the found value
        Yf = r.Row      ''r is a range, this command finds the first Column of that range
        
        ' this is a scratch pad location, stores the found value's row number, which is needed for copy-paste of row
        Cells(Totaln, lColi + 7) = r.Row
        
        
        Cells(Yf, Xf).Select
        ActiveCell.Interior.ColorIndex = 6
        ActiveCell.Font.FontStyle = "Bold Italic"
        ActiveCell.Font.ColorIndex = 3

        Valf = ActiveCell.Value
        ValfStr = "  " + CStr(Valf) + "  = Requested Value found"

    '    Range("AC1") = Totaln       ' Total number of values found
     '   Range(Cells(lColi + 3), Cells(lColi + 3)) = Totaln    ' Total number of values found
    '    Range("AC2") = MyString   'list of row for the values found
    '    Range("AC3") = ValfStr  ' value = "Requested Value...
               
'****************************

    Loop
    
    If nFail Then
        'MsgBox "You entered no number!"
    Else
        TotalinfoString = "Total number of Results = " + CStr(Totaln)
        'MsgBox CStr(Totaln)
        MsgBox TotalinfoString
        If Totaln <> 0 Then
            MyString = "Results Found at Row #'s:   " + MyString
            MsgBox MyString
        Else
        End If
    End If
    
' Insert some rows
    Range("A1").Select  ' move back to the top of the page.
    If Not nFail Then
        If Not nStop Then
            If Not rFirst Is Nothing Then
                Range("A1:A" & Totaln + 2 + 1).EntireRow.Insert
                Range("B" & Totaln + 2 + 1) = "DELETE FLAG"
'                Range("D" & Totaln + 2 + 1) = Totaln + 2 + 1
                Range("D" & Totaln + 2 + 1) = Totaln
                Range("F" & Totaln + 2 + 1) = " = Total No. of Search Results"
' select and copy the titles
                Range("A1").Select  ' move back to the top of the page.
                Range(Cells(Totaln + 2 + 2, 1), Cells(Totaln + 3 + 2, lCol)).Select
                Selection.Copy
' Paste the titles in
                Range("A1").Select  ' move back to the top of the page.
' paste in the titles
                Selection.PasteSpecial Paste:=xlPasteFormats, Operation:=xlNone, _
                    SkipBlanks:=False, Transpose:=False
                Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
                    :=False, Transpose:=False
                Range("A3").Select
                Copyn = 1
                Do While Copyn <= Totaln
                    CopyRow = Cells(Totaln + 2 + 1 + Copyn, lColi + 7).Value
'Range(Cells(Totaln + 5+ Range("X"& Totaln+5, 1)).Select
                    Range(Cells(CopyRow + Totaln + 2 + 1, 1), Cells(CopyRow + Totaln + 2 + 1, lCol)).Select
                    Selection.Copy   ' copy and paste the found data in the new space at the top
                    Cells(Copyn + 2, 1).Select
                    Selection.PasteSpecial Paste:=xlPasteFormats, Operation:=xlNone, _
                        SkipBlanks:=False, Transpose:=False
                    Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
                        :=False, Transpose:=False

                    Copyn = Copyn + 1
                    
'                   'Range("W1") = CopyRow  ' used for debugging
'                   'Range ("X1")=Totaln    ' used for debugging

                Loop
                Range("A1").Select
                Else
            End If
        End If
    End If
    
'*****************************************
    ' Delete a few columns at right to clean up and to make the new last column a Null value.
    i = 1
    imax = 8
    Columns(lColi + 1 + imax).EntireColumn.Insert
    While i < imax + 1
        Columns(lColi + 1).EntireColumn.Delete
        i = i + 1
    Wend

        
    
     ' Place cursor at the top left and stop
        Range("A1").Select
    End Sub


