Attribute VB_Name = "Module03_DeleteSrchResultTop"
Sub DeleteSrchResultTopRows()
Attribute DeleteSrchResultTopRows.VB_Description = "Ctrl+Shift+D,  Delete Srch Top Rows"
Attribute DeleteSrchResultTopRows.VB_ProcData.VB_Invoke_Func = "D\n14"

'Ctrl+Shift+D,  Delete Srch Top Rows

' This Subroutine call deletes the lines from All previous search of AllTPI and then clears the columns to the right of the TPI table.
' If a previous search has not occcured to cause the phrase "DELETE FLAG" to
' exist then this program does nothing.... so it is safe to run under all conditions.


    Dim Xf As Long ' to be the found column number
    Dim Yf As Long  ' to be the found row number
Dim Valf As Double ' what is the value found in the cell found
Dim ValfStr As String ' cell value to display
Dim ShSearch As String
Dim lRow As Long ' last row number of the data
Dim lCol As Long ' last column number of the data
Dim lColi As Long
Dim TPIRangeCol3 As Range  ' range of actual data in column 3
Dim AllDataRange As Range  ' range of actual data in sheet
Dim TPIsrch As String  ' the TIP to be searched for, input from the user msgbox
Dim MsgStr As String  ' long message box string to the user
   Dim Totaln As Long
   Dim rFirst As Range
   Dim r As Range
   Dim A As Range
   Dim MyString As String
Dim Copyn As Long
Dim CopyRow As Long
    Dim DeleteFlagCnt As Long
    Dim DeleteRowCnt As Long

    ShSearch = "AllTPI"
    For Each Sheet In ActiveWorkbook.Worksheets
        If Sheet.Name = ShSearch Then
            Exit For
        Else
        MsgStr = "There is no " + ShSearch + " sheet to Search, Please run: GenAllTPI"
        MsgBox MsgStr, vbOKOnly, "Missing Sheet"
        Exit Sub
        End If
    Next
      
    Sheets(ShSearch).Select
' How many "DELETE FLAG" occurrences are present, DeleteFlagCnt.
    lRow = Cells(Rows.Count, "C").End(xlUp).Row
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
    lColi = lCol
    
    DeleteFlagCnt = Application.WorksheetFunction.CountIf(Range(Cells(1, 2), Cells(lRow, 2)), "DELETE FLAG")


 DeleteRowCnt = 0

Do While DeleteRowCnt < DeleteFlagCnt
    lRow = Cells(Rows.Count, "C").End(xlUp).Row
    Stopn = False
    Yf = 0
    lRow = Cells(Rows.Count, 3).End(xlUp).Row
    Do While Yf < lRow
        Yf = Yf + 1
        If Cells(Yf, 2) = "DELETE FLAG" Then
            Stopn = True
        End If
        If Stopn Then Exit Do
    Stopn = False
    Loop
    DeleteRowCnt = DeleteRowCnt + 1

    If DeleteRowCnt <= DeleteFlagCnt Then
        Cells(1, lCol + 1) = Yf
        Cells(Yf + 1, lCol + 1) = Yf ' this is the number of rows to be deleted.
        lRow = Cells(Yf + 1, lCol + 1)
        Yf = 0
    Do While Yf < lRow
        Rows(1).EntireRow.Delete
        Yf = Yf + 1
    Loop
    End If
Loop
    
    
    
    
    If Stopn = True Then
        Columns(lColi + 1 + 8).EntireColumn.Insert
        Columns(lColi + 1).EntireColumn.Delete
        Columns(lColi + 1).EntireColumn.Delete
        Columns(lColi + 1).EntireColumn.Delete
        Columns(lColi + 1).EntireColumn.Delete
        Columns(lColi + 1).EntireColumn.Delete
        Columns(lColi + 1).EntireColumn.Delete
        Columns(lColi + 1).EntireColumn.Delete
        Columns(lColi + 1).EntireColumn.Delete
    Else
    End If
    
    Range("AA2") = CStr(DeleteFlagCnt)  'debug purposes

    End Sub


